<template>
  <v-container>
    <v-btn @click="openDialog(null)">Adicionar Produto</v-btn>
    <v-data-table :items="items" :headers="headers" :loading="loading">
      <template #item.actions="{ item }">
        <v-btn icon @click="openDialog(item)">
          <v-icon>mdi-pencil</v-icon>
        </v-btn>
        <v-btn icon @click="removerItem(item.id.toString())">
          <v-icon>mdi-delete</v-icon>
        </v-btn>
      </template>
      <template #loading>
        <v-progress-circular indeterminate size="64"></v-progress-circular>
      </template>
    </v-data-table>

    <v-dialog v-model="dialog" max-width="500px">
      <template #default="dialog">
        <v-card>
          <v-card-text>
            <generic-form :item-edit="itemEdit" :formTitle="formTitle" :fields="fields" @save="salvarItem" @close="dialog = false"></generic-form>
          </v-card-text>
        </v-card>
      </template>
    </v-dialog>
  </v-container>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import GenericForm from './ProdutoForm.vue';
import Produto from '../../../domain/entities/Produto';
import { useProdutoStore } from '../stores/produtoStore';
import { useEntityMixin } from './entityMixin';
import { useCategoriaStore } from '../stores/categoriaStore';


export default defineComponent({
  components: {
    GenericForm,
  },
  setup() {

    const formTitle = "Produtos";
    const headers = [
      { title: 'Nome', key: 'nome', sortable: true, align: 'start' },
      { title: 'Preço', key: 'preco', sortable: true, align: 'end' },
      { title: 'Categoria', key: 'categoriaId', sortable: true, align: 'start' },
      { title: 'Ações', key: 'actions', sortable: false, align: 'center' },
    ];
    const defaultProduto = (): Produto => new Produto(0, '', 0, 0);

    const { items, dialog, itemEdit, openDialog, salvarItem, removerItem, loading } =
      useEntityMixin<Produto>(useProdutoStore(), defaultProduto);


    const fields = [
      { name: 'nome', label: 'Nome do Produto', type: 'text', required: true },
      { name: 'preco', label: 'Preço do Produto', type: 'text', required: true },
      { name: 'categoriaId', label: 'Categoria', type: 'select', required: true },
    ];


    return {
      items,
      dialog,
      itemEdit,
      formTitle,
      headers,
      openDialog,
      salvarItem,
      removerItem,
      loading,
      fields,
    };
  },
});
</script>

<style scoped>
.v-dialog .v-card {
  background-color: white;
}

</style>